// GlassTerm.CPP
//
// Copyright (c) 2003 Alexander K. Seewald
//

// Communication via BlueTooth Serial (Stollmann) Adapter
// - works for now!
// first application: BlueCar - BlueTooth Remote Control

#include <es_sock.h>
#include <bt_sock.h>

#include "CommonFiles.h"


LOCAL_C void doExampleL ()
{
	// WARNING: do not use ServoID=0, since it clashes
	// with the zero-terminated string end marker... :->
	int x=128-50;
	int xServoID=2; // Steering
	int y=128;
	int yServoID=4; // Speed

	int dY=-1; // speed parameter...
        int dX=22; // drive parameter (half/full left/right)
        int xmin=x-2*dX; int xmax=x+2*dX;

	TBufC8<4> msg;

	TUint8 cmd[4];
	cmd[0]=255;
	cmd[1]=xServoID;
	cmd[2]=x;
	cmd[3]=0; // pseudo zero-terminated string ;-)
    
	RSocketServ iSocketServer;

	User::LeaveIfError(iSocketServer.Connect());

	RSocket iSendingSocket;
	User::LeaveIfError(iSendingSocket.Open(iSocketServer,_L("RFCOMM")));

	TInt64 physAdr(0x00000080,0x2500215E);
	TBTDevAddr devA(physAdr);
	TBTSockAddr addr;
	TRequestStatus iStatus;

	addr.SetBTAddr(devA);
	addr.SetPort(1);

	iSendingSocket.Connect(addr,iStatus);

	if (iStatus.Int()==KRequestPending) {
	  User::WaitForRequest(iStatus);
	}
	User::LeaveIfError(iStatus.Int());

	console->Printf(_L("Welcome to BlueCar!\nUse Joystick to move.\n\n"));
	// left & right: increase/decrease dX

	TKeyCode key;
	TRequestStatus keyStatus;
	for (;;) {
        console->Read(keyStatus);
	User::WaitForRequest(keyStatus);
        key=console->KeyCode();
	    if      (key==63497) { y+=dY; }
	    else if (key==63498) { y-=dY; }
	    else if (key==63495) { x-=dX; if (x<xmin) { x=xmin; }}
	    else if (key==63496) { x+=dX; if (x>xmax) { x=xmax; }}
		else if (key==63554) { dX--; }
		else if (key==63555) { dX++; }
		else {
	      break;
		}

		console->Printf(_L("x:%d,y:%d\n"),x,y);

        if (key>63496) {
			cmd[1]=yServoID; cmd[2]=y;
		} else {
			cmd[1]=xServoID; cmd[2]=x;
		}
		
		msg=cmd; iSendingSocket.Write(msg,iStatus);
	}

    // reset to default values...
    cmd[1]=yServoID; cmd[2]=128; msg=cmd; iSendingSocket.Write(msg,iStatus);
    cmd[1]=xServoID; cmd[2]=128-50; msg=cmd; iSendingSocket.Write(msg,iStatus);

	console->Printf(_L("Thanks for testing!\nFinal dX=%d.\n"),dX);

	iSendingSocket.Close();
	iSocketServer.Close();
}
